/*
 * DS18b20.h
 *
 * Created: 27.09.2020 3:24:00
 *  Author: 123
 */ 


#ifndef DS18B20_H_
#define DS18B20_H_

#include "main.h"

#define CMD_CONVERTTEMP    0x44
#define CMD_RSCRATCHPAD    0xbe
#define CMD_WSCRATCHPAD    0x4e
#define CMD_CPYSCRATCHPAD  0x48
#define CMD_RECEEPROM      0xb8
#define CMD_RPWRSUPPLY     0xb4
#define CMD_SEARCHROM      0xf0
#define CMD_READROM        0x33
#define CMD_MATCHROM       0x55
#define CMD_SKIPROM        0xcc
#define CMD_ALARMSEARCH    0xec

#ifdef __AVR__
#define MOW_CLI() uint8_t oldSreg = SREG; cli();
#define MOW_SEI() SREG = oldSreg
#else
#define MOW_CLI()
#define MOW_SEI()
#endif


class DS18B20 {
	private:
		unsigned char DQ;
		unsigned char reset( void );
		unsigned char read_packet( void );
		void write_packet( unsigned char byte );
	public:
		DS18B20 (unsigned char pin);
		void beginConversion( void );
		double readTemp( void );
};


#endif /* DS18B20_H_ */