/*
 * main.h
 *
 * Created: 16.10.2020 9:20:32
 *  Author: user
 */ 


#ifndef MAIN_H_
#define MAIN_H_

typedef unsigned long int DWORD;

#define F_CPU 8000000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#define bytesJoin(value, b1, b2, b3, b4) value = b1; value <<= 8UL; value |= b2; value <<= 8UL; value |= b3; value <<= 8UL; value |= b4;
#define setInterval(n, tmr, code) { if ((millis - tmr) >= n) { tmr = millis; code; }}

const unsigned char groups[8] = {
	0b11101111,
	0b11110111,
	0b11111011,
	0b11011111,
	0b11111101,
	0b01111111,
	0b11111110,
	0b10111111
};
// C D DP E F B G A
//     (LSBFIRST)
const unsigned char digits[11] = {//     A
	0b00100010,         //0          #########
	0b01111011,         //1         #         #
	0b10101000,         //2       F #         # B
	0b00111000,         //3         #    G    #
	0b01110001,         //4          #########
	0b00110100,         //5         #         #
	0b00100100,         //6       E #         # C
	0b01111010,         //7         #         #
	0b00100000,         //8          #########
	0b00110000,         //9              D       ##
	0b00000000          //8.                     dp
};

const unsigned char animation_clock_chars[5] = {
	0b01110111,
	0b10111110,
	0b11101011,
	0b01110111,
	0b10111110
};

const unsigned char divider_horizontal	= 0b11111101;
const unsigned char animation_char		= 0b11111101;
const unsigned char cel_symbol			= 0b11110000;
const unsigned char dp_bit				= 5;
const unsigned char NC                  = 0xFF;
const unsigned char chars[6] = {
	0b11101101, // r
	0b00101001, // d
	0b00110001, // Y
	0b01100010, // N
	0b10100100, // E
	0b01100000  // A
};



#include "WFast.h"
#include "i2c.h"
#include "SPI.h"
#include "DS18B20.h"
#include "ds3231.h"
//#include "display.h"
//#include "main_data.h"
#include "button.h"
#include "EEPROM.h"

#define INTERRUPT ISR
#define IRQ0_isr INT0_vect
#define IRQ1_isr INT1_vect
#define TIM0_OVF_isr TIMER0_OVF_vect
#define TIM1_OVF_isr TIMER1_OVF_vect
#define TIM2_OVF_isr TIMER2_OVF_vect
#define USART_RX_isr USART_RX_vect

#define OK_BTN B0
#define DOWN_BTN D7
#define UP_BTN D6
#define MENU_BTN D5

#endif /* MAIN_H_ */