﻿// Функция отображения температуры. Поддержка отрицательных значений. В общем 
// говорить тут особо нечего - тут куча математических вычислений
void printTemperature(float temp) {
	// Если число отрицательное - просто убираем минус и работаем как с обычным числом )
	if (temp < 0) {
		temp = fabs(temp);
		display_data[1] = divider_horizontal; // Но пририсуем минус во втором разряде
	} else {
		display_data[1] = NC; // Если положительное число - очищаем второй разряд
	}
	
	// Очищаем все остальное
	display_data[0] = NC;
	display_data[6] = NC;
	display_data[7] = NC;
	
	if (temp == 0.0F) { // Если температрура 0°, то...
		display_data[2] = digits[0] & ~(1 << dp_bit); // Отображаем 0. в третьем разряде
		display_data[3] = digits[0]; // Ноль в четвертом разряде
		display_data[4] = cel_symbol; // занчок ° в пятом разряде
		display_data[5] = NC; // Очищаем шестой разряд, если там что-то было до этого
	} else if (temp >= 0.1F && temp <= 9.9F) { // Если температура больше 0.1° и меньше 9.9°, то...
		display_data[2] = digits[(int)temp] & ~(1 << dp_bit); // Округляем значение до ближайшего и ставим точку после него
		display_data[3] = digits[(int)(temp * 10.0F) % 10]; // Умножаем число на 10 и остаток от деления на 10 - будет второй разряд 
		display_data[4] = cel_symbol; // Дальше значок цельсия
		display_data[5] = NC; // Если тут что-то было до этого, то удаляем
	} else if (temp >= 10.0F && temp <= 99.9F) { // Если температура больше или равна 10.0° и меньше или равна 99.9°, то...
		display_data[2] = digits[(int)(temp) % 100 / 10]; // Первый разряд это - остаток от деления на 100, разделенный на 10
		display_data[3] = digits[(int)(temp) % 10] & ~(1 << dp_bit); // Второй разряд это остаток от деления на 10. так-же ставим точку
		display_data[4] = digits[(int)(temp * 10.0F) % 10]; // Третий разряд - это остаток от деления на десять, от числа умноженного на десять
		display_data[5] = cel_symbol; // Отображаем занчок цельсия
	}
}

/*
	 Функция отображения даты
		День, месяц, год - это основные аргументы
		dVisible, mVisible, yVisible - Параметры отображения дня, месяца и года. 1 - отображается, 0 - не отображается
		dt - параметр отображения точки-разделителя между днем, месяцем и годом
*/
void printDate(int day, int month, int year, int dVisible=1, int mVisible=1, int yVisible=1, unsigned char dt=1) {
	if (dVisible) { // Если мы хотим отображать дни, то ..
		if (day == 0) { // Если день равен нулю (такое конечно не возможно, но я был-бы не я - если-бы фунция не умела полноценно числа отображать)
			display_data[0] = digits[0]; // В первый разряд помещаем ноль
			display_data[1] = (dt) ? digits[0] | (1 << 6) : digits[0]; // И сюда ноль. При надобностьи отображаем точку-разделитель
		} else if (day >= 1 && day <= 9) { // Дни от 1 до 9
			display_data[0] = digits[0]; // Отображаем ведущий ноль
			display_data[1] = (dt) ? digits[day] | (1 << 6) : digits[day]; // Отображаем день
		} else if (day >= 10 && day <= 99) { // Дни от 10 до 99
			display_data[0] = digits[(unsigned char)((day % 100) / 10)]; // Известной нам формулой получаем первые разряд
			display_data[1] = (dt) ? digits[(unsigned char)(day % 10)] | (1 << 6) : digits[(unsigned char)(day % 10)]; // и второй. При надобности показываем точку-разделитель
		}
	} else {
		// Если не отображаем - то не отобраем. Оставляем только точку-разделитель
		display_data[0] = NC;
		display_data[1] = 0b01000000;
	}
	/*
		С месяцем и годом - все тоже самое, мне лень все это расписывать )))))
	*/
	if (mVisible) {
		if (month == 0) {
			display_data[2] = digits[0];
			display_data[3] = (dt) ? digits[0] | (1 << 6) : digits[0];
		} else if (month > 0 && month <= 9) {
			display_data[2] = digits[0];
			display_data[3] = (dt) ? digits[month] | (1 << 6) : digits[month];
		} else if (month >= 10 && month <= 99) {
			display_data[2] = digits[(unsigned char)((month % 100) / 10)];
			display_data[3] = (dt) ? digits[(unsigned char)(month % 10)] | (1 << 6) : digits[(unsigned char)(month % 10)];
		}
	} else {
		display_data[2] = NC;
		display_data[3] = 0b01000000;
	}
	if (yVisible) {
		if (year == 0) {
			display_data[4] = digits[2];
			display_data[5] = digits[0];
			display_data[6] = digits[0];
			display_data[7] = digits[0];
		} else if (year > 0 && year <= 9) {
			display_data[4] = digits[2];
			display_data[5] = digits[0];
			display_data[6] = digits[0];
			display_data[7] = digits[year];
		} else if (year >= 10 && year <= 99) {
			display_data[4] = digits[2];
			display_data[5] = digits[0];
			display_data[6] = digits[(unsigned char)((year % 100) / 10)];
			display_data[7] = digits[(unsigned char)(year % 10)];
		}
	} else {
		display_data[4] = NC;
		display_data[5] = NC;
		display_data[6] = NC;
		display_data[7] = NC;
	}
}

/*
	Функция отображение времени на дисплее
	hour, minutes, seconds - Часы, минуты и секунды
	hVisible, mVisible, sVisible - отображение. 0 - Не отображать, 1 - Отображать
	
	Функция почти идентична функции printDate, тут расписывать ничего не буду.
*/
void printTime(int hour, int Minutes, int Seconds, int hVisible=1, int mVisible=1, int sVisible=1) {
	if (hVisible) {
		if (hour == 0) {
			display_data[0] = digits[0];
			display_data[1] = digits[0];
		} else if (hour > 0 && hour <= 9) {
			display_data[0] = digits[0];
			display_data[1] = digits[hour];
		} else if (hour >= 10 && hour <= 99) {
			display_data[0] = digits[(unsigned char)((hour % 100) / 10)];
			display_data[1] = digits[(unsigned char)(hour % 10)];
		}
	} else {
		display_data[0] = NC;
		display_data[1] = NC;
	}
	
	if (mVisible) {
		if (Minutes == 0) {
			display_data[3] = digits[0];
			display_data[4] = digits[0];
		} else if (Minutes > 0 && Minutes <= 9) {
			display_data[3] = digits[0];
			display_data[4] = digits[Minutes];
		} else if (Minutes >= 10 && Minutes <= 99) {
			display_data[3] = digits[(unsigned char)((Minutes % 100) / 10)];
			display_data[4] = digits[(unsigned char)(Minutes % 10)];
		}
	} else {
		display_data[3] = NC;
		display_data[4] = NC;
	}
	
	if (sVisible) {
		if (Seconds == 0) {
			display_data[6] = digits[0];
			display_data[7] = digits[0];
		} else if (Seconds > 0 && Seconds <= 9) {
			display_data[6] = digits[0];
			display_data[7] = digits[Seconds];
		} else if (Seconds >= 10 && Seconds <= 99) {
			display_data[6] = digits[(unsigned char)((Seconds % 100) / 10)];
			display_data[7] = digits[(unsigned char)(Seconds % 10)];
		}
	} else {
		display_data[6] = NC;
		display_data[7] = NC;
	}
}

// Функция отображения черточек-разделителей
void printDividers (char print) {
	if (print) {
		display_data[2] = divider_horizontal;
		display_data[5] = divider_horizontal;
	} else {
		display_data[2] = NC;
		display_data[5] = NC;
	}
}
